function y=prob2d(X, D)
% This function will train a neural network with inputs X and desired outputs D.
% X has its first column set to all ones, indicating an applied bias.

global W

learningRate = 0.1;     % learning rate for weight updates
nodeCount = [200, 2];     % number of nodes for each non-input layer (comma-separated)
logisticWeight = 1;       % weight of the logistic activation functions
maxError = 0.1;          % network trained when mean error length is below this
weightDecay = 1e-3;      % weight decay for complexity regularization
displayEpochs = 25;       % epochs between updating the progress display

% Translate the inputs and the desired outputs into a format that my code expects
input = X(:,2:3);

% Set things up so that the inputs act like a first layer of nodes - since 
% outputs are denoted by 'y,' these are the outputs of layer 1, e.g. y{1}.
nodeCount = [size(input,2) nodeCount];

% Make room for a bias input in each layer (except the output layer)
nodeCount = nodeCount + 1;
nodeCount(length(nodeCount)) = nodeCount(length(nodeCount)) - 1;

% Scale the inputs so they have a mean of zero and a variance of one
%meanX = mean(input);
%stdX = std(input);
%input = (input - repmat(meanX, length(input), 1))./repmat(stdX, length(input), 1);

% Find the weights that properly satisfy the XOR function
figure(1); gcf;
W = computeWeights( maxError, learningRate, nodeCount, input, D,     ...
                    logisticWeight, weightDecay, displayEpochs);
                
% Compute the output for every possible input
x1 = -10:.2:10;
x2 = -10:.2:10;
for i=1:length(x1);
    for j=1:length(x2);
%        x = ([x1(i), x2(j)] - meanX) ./ stdX;
        x = [x1(i), x2(j)];
        y = computeOutputs(nodeCount, x, W, logisticWeight);
        output(j,i,1) = y{3}(1);
        output(j,i,2) = y{3}(2);
    end;
end;
figure(2);
contourf(x1, x2, output(:,:,1), 20);
%shading interp;
figure(3);
contourf(x1, x2, output(:,:,2), 20);
%shading interp;

return;