%----------------------------------------------------------------
%
% Compute the posterior probability for class one from knowledge
% of the data generator!
%

prior1 = (frac11+frac12)/fsum;        % class prior probabilities
prior2 = (frac21+frac22+frac23)/fsum;
step = 1/5; start=10;
[X1,X2]=meshgrid(-start:step:start,-start:step:start);
Y=zeros(size(X1));
for i=1:size(X1,1)
   for j=1:size(X1,2)
      x = [X1(i,j) X2(i,j)];
      % Class one mixture of Gaussians
      class1 = ...
          frac11/(frac11+frac12) * ...
          (1/var11)*exp( -0.5* (x-center11)*(x-center11)' / var11^2 ) + ...
          frac12/(frac11+frac12) * ...
          (1/var12)*exp( -0.5* (x-center12)*(x-center12)' / var12^2 );
      % Class two mixture of Gaussians
      class2 = ...
          frac21/(frac21+frac22+frac23) * ...
          (1/var21)*exp( -0.5* (x-center21)*(x-center21)' / var21^2 ) + ...
          frac22/(frac21+frac22+frac23) * ...
          (1/var22)*exp( -0.5* (x-center22)*(x-center22)' / var22^2 ) + ...
          frac23/(frac21+frac22+frac23) * ...
          (1/var23)*exp( -0.5* (x-center23)*(x-center23)' / var23^2 );
      % just use Bayes' rule
      Y(i,j) =  class1*prior1 / (class1*prior1 + class2*prior2);
   end
end
figure(4);
colormap(hot);
surf(X1,X2,Y); % twenty levels, the decision surface (class one 
                      % posterior probability = 0.5)will be in the 
                      % middle of the scale (reddish orange)
